<?php

namespace patest\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfTraceFilterItem ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfTraceFilterItem
 * @subpackage Arrays
 */
class ArrayOfTraceFilterItem extends AbstractStructArrayBase
{
    /**
     * The TraceFilterItem
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \patest\StructType\TraceFilterItem[]
     */
    public $TraceFilterItem;
    /**
     * Constructor method for ArrayOfTraceFilterItem
     * @uses ArrayOfTraceFilterItem::setTraceFilterItem()
     * @param \patest\StructType\TraceFilterItem[] $traceFilterItem
     */
    public function __construct(array $traceFilterItem = array())
    {
        $this
            ->setTraceFilterItem($traceFilterItem);
    }
    /**
     * Get TraceFilterItem value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \patest\StructType\TraceFilterItem[]|null
     */
    public function getTraceFilterItem()
    {
        return isset($this->TraceFilterItem) ? $this->TraceFilterItem : null;
    }
    /**
     * This method is responsible for validating the values passed to the setTraceFilterItem method
     * This method is willingly generated in order to preserve the one-line inline validation within the setTraceFilterItem method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateTraceFilterItemForArrayConstraintsFromSetTraceFilterItem(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfTraceFilterItemTraceFilterItemItem) {
            // validation for constraint: itemType
            if (!$arrayOfTraceFilterItemTraceFilterItemItem instanceof \patest\StructType\TraceFilterItem) {
                $invalidValues[] = is_object($arrayOfTraceFilterItemTraceFilterItemItem) ? get_class($arrayOfTraceFilterItemTraceFilterItemItem) : sprintf('%s(%s)', gettype($arrayOfTraceFilterItemTraceFilterItemItem), var_export($arrayOfTraceFilterItemTraceFilterItemItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The TraceFilterItem property can only contain items of type \patest\StructType\TraceFilterItem, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set TraceFilterItem value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \patest\StructType\TraceFilterItem[] $traceFilterItem
     * @return \patest\ArrayType\ArrayOfTraceFilterItem
     */
    public function setTraceFilterItem(array $traceFilterItem = array())
    {
        // validation for constraint: array
        if ('' !== ($traceFilterItemArrayErrorMessage = self::validateTraceFilterItemForArrayConstraintsFromSetTraceFilterItem($traceFilterItem))) {
            throw new \InvalidArgumentException($traceFilterItemArrayErrorMessage, __LINE__);
        }
        if (is_null($traceFilterItem) || (is_array($traceFilterItem) && empty($traceFilterItem))) {
            unset($this->TraceFilterItem);
        } else {
            $this->TraceFilterItem = $traceFilterItem;
        }
        return $this;
    }
    /**
     * Add item to TraceFilterItem value
     * @throws \InvalidArgumentException
     * @param \patest\StructType\TraceFilterItem $item
     * @return \patest\ArrayType\ArrayOfTraceFilterItem
     */
    public function addToTraceFilterItem(\patest\StructType\TraceFilterItem $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \patest\StructType\TraceFilterItem) {
            throw new \InvalidArgumentException(sprintf('The TraceFilterItem property can only contain items of type \patest\StructType\TraceFilterItem, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->TraceFilterItem[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \patest\StructType\TraceFilterItem|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \patest\StructType\TraceFilterItem|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \patest\StructType\TraceFilterItem|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \patest\StructType\TraceFilterItem|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \patest\StructType\TraceFilterItem|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string TraceFilterItem
     */
    public function getAttributeName()
    {
        return 'TraceFilterItem';
    }
}
